unit CreateSaveBackFile_MainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,_m_Tools;

type
  TMain = class(TForm)
    DriveLst: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

const M3SAKURAFilename='SYSTEM\m3sakura\m3sakura.dat';
const SAVEBACKFilename='SYSTEM\m3sakura\saveback.dat';

procedure CheckInstalledDrives;
var
  idx:integer;
  fn:string;
  rfs:TFileStream;
begin
{
  Main.DriveLst.Items.Add('T:\ [direct]');
  Main.DriveLst.ItemIndex:=0;
  exit;
}

  Main.DriveLst.Clear;
  for idx:=2 to 26-1 do begin
    fn:=char($41+idx)+':\';
    if GetDriveInfomation(fn).Enabled=True then begin
      try
        rfs:=TFileStream.Create(fn+M3SAKURAFilename,fmOpenRead);
        rfs.Free;
        Main.DriveLst.Items.Add(fn+' ['+GetDriveInfomation(fn).VolumeLabel+']');
        except else begin
        end;
      end;
    end;
  end;
  if Main.DriveLst.Items.Count<>0 then Main.DriveLst.ItemIndex:=Main.DriveLst.Items.Count-1;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  CheckInstalledDrives;

  if DriveLst.Items.Count=0 then begin
    ShowMessage('M3SakuraCXg[ꂽfBXN܂łB');
    Application.Terminate;
    exit;
  end;
end;

procedure TMain.BitBtn2Click(Sender: TObject);
begin
  Main.Close;
end;

const SaveBackInfoCount=16;

function BootROM_Execute_CallBack_SaveDataBackup_GetRequestFileSize:integer;
begin
  Result:=0;
  inc(Result,512); // dummy header.
  inc(Result,512*SaveBackInfoCount); // Infos.
  inc(Result,(512*1024)*SaveBackInfoCount); // Save data backup body.
end;

procedure TMain.BitBtn1Click(Sender: TObject);
var
  fn:string;
  wfs:TFileStream;
  errorflag:boolean;
  function WriteHeader:boolean;
  var
    StartPath:string;
    headerfn:string;
    rfs:TFileStream;
    buf:array[0..512-1] of byte;
  begin
    Result:=False;
    StartPath:=ExtractFilePath(Application.ExeName);
    headerfn:=StartPath+'CreateSaveBackFile_header.dat';
    rfs:=TFileStream.Create(headerfn,fmOpenRead);
    if rfs.Size<>512 then begin
      ShowMessage('Illigal file size. '+headerfn);
      Application.Terminate;
      exit;
    end;
    rfs.ReadBuffer(buf[0],512);
    rfs.Free;
    wfs.WriteBuffer(buf[0],512);
    Result:=True;
  end;
begin
  BitBtn1.Enabled:=False;
  Application.ProcessMessages;

  fn:=copy(DriveLst.Text,1,3)+SAVEBACKFilename;

  if FileExists(fn)=True then begin
    if MessageDlg('łɎobNAbvt@C݂܂B'+CRLF+'t@Cčč쐬܂H',mtWarning,[mbYes,mbNo],0)<>mrYes then begin
      BitBtn1.Enabled:=True;
      exit;
    end;
  end;

  wfs:=TFileStream.Create(fn,fmCreate);

  if WriteHeader=False then exit;

  errorflag:=False;
  try
    wfs.Size:=BootROM_Execute_CallBack_SaveDataBackup_GetRequestFileSize;
    except else begin
      errorflag:=True;
    end;
  end;

  wfs.Free;

  BitBtn1.Enabled:=True;

  if errorflag=True then begin
    DeleteFile(fn);
    ShowMessage('t@C̍쐬ɃG[܂B'+CRLF+'fBXNĂ邩󂫗eʂȂ\܂B');
    Application.Terminate;
    exit;
  end;

  ShowMessage('obNAbvt@C쐬܂B'+CRLF+fn+CRLF+CRLF+'obNAbv߂Ƃ́ALt@C폜ĂB');
  Application.Terminate;
end;

end.
