unit ExtractSaveBackFile_MainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TMain = class(TForm)
    InfoLst: TListBox;
    StartupTimer: TTimer;
    Label1: TLabel;
    ExtractBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label2: TLabel;
    SaveDlg: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure StartupTimerTimer(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure ExtractBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Main: TMain;

implementation

uses ExtractSaveBackFile_DrvSelWin;

{$R *.dfm}

const M3SAKURAFilename='SYSTEM\m3sakura\m3sakura.dat';
const SAVEBACKFilename='SYSTEM\m3sakura\saveback.dat';

var
  rfs:TFileStream;

procedure TMain.FormCreate(Sender: TObject);
begin
  rfs:=NIL;
  StartupTimer.Enabled:=True;
end;

type
  TSaveBackInfo=record
    SlotIndex:integer;
    SaveSize:dword;
    SaveDateTime64:int64;
    FullPathUnicode:string;
  end;

const SaveBackInfoMaxCount=16;
var
  SaveBackInfos:array[0..SaveBackInfoMaxCount] of TSaveBackInfo;
  SaveBackInfoCount:integer;

procedure TMain.StartupTimerTimer(Sender: TObject);
var
  idx:integer;
  SaveDateTime64:int64;
  TargetIndex:integer;
  b8:byte;
  str:string;
  function LoadInfo(idx:integer;var SaveBackInfo:TSaveBackInfo):boolean;
  var
    dw:dword;
    widx:integer;
    wch:widechar;
    wfn:widestring;
  begin
    rfs.Position:=512+(512*idx);
    SaveBackInfo.SlotIndex:=idx;

    rfs.ReadBuffer(dw,4);
    if dw=0 then begin
      Result:=False;
      exit;
    end;
    SaveBackInfo.SaveSize:=dw;

    rfs.ReadBuffer(dw,4);
    SaveDateTime64:=dw;
    rfs.ReadBuffer(dw,4);
    SaveDateTime64:=(SaveDateTime64 shl 32) or dw;
    SaveBackInfo.SaveDateTime64:=SaveDateTime64;

    wfn:='';
    for widx:=0 to (256-((4*3) div 2))-1 do begin
      rfs.ReadBuffer(wch,2);
      if word(wch)=0 then break;
      if wch='/' then wch:='\';
      wfn:=wfn+wch;
    end;
    SaveBackInfo.FullPathUnicode:=wfn;

    Result:=True;
  end;
begin
  StartupTimer.Enabled:=False;

  if DrvSel.CheckInstalledDrives=False then begin
    ShowMessage('M3Sakura̎obNAbvt@C쐬ꂽfBXN܂łB');
    Application.Terminate;
    exit;
  end;

  DrvSel.Caption:=Main.Caption;
  if DrvSel.ShowModal<>mrOk then begin
    Application.Terminate;
    exit;
  end;

  SaveBackInfoCount:=0;

  rfs:=TFileStream.Create(DrvSel.TargetDrive+SAVEBACKFilename,fmOpenRead);

  rfs.Position:=511;
  rfs.ReadBuffer(b8,1);
  TargetIndex:=b8;

  for idx:=TargetIndex to SaveBackInfoMaxCount-1 do begin
    if LoadInfo(idx,SaveBackInfos[SaveBackInfoCount])=True then inc(SaveBackInfoCount);
  end;

  for idx:=0 to TargetIndex-1 do begin
    if LoadInfo(idx,SaveBackInfos[SaveBackInfoCount])=True then inc(SaveBackInfoCount);
  end;

  if SaveBackInfoCount=0 then begin
    ShowMessage('obNAbvꂽXbgЂƂ܂łB');
    Application.Terminate;
    exit;
  end;

  InfoLst.Clear;

  for idx:=0 to SaveBackInfoCount-1 do begin
    SaveDateTime64:=SaveBackInfos[idx].SaveDateTime64;
    str:='';
    str:=str+format('%4.0d/',[(SaveDateTime64 shr (16+32)) and $ffff]);
    str:=str+format('%2.0d/',[(SaveDateTime64 shr (8+32)) and $ff]);
    str:=str+format('%2.0d ',[(SaveDateTime64 shr (0+32)) and $ff]);
    str:=str+format('%2.0d:',[(SaveDateTime64 shr (16+0)) and $ffff]);
    str:=str+format('%0.2d:',[(SaveDateTime64 shr (8+0)) and $ff]);
    str:=str+format('%0.2d ',[(SaveDateTime64 shr (0+0)) and $ff]);
    str:=str+ExtractFilename(SaveBackInfos[idx].FullPathUnicode);
    InfoLst.Items.Add(str);
  end;

  InfoLst.ItemIndex:=InfoLst.Items.Count-1;
end;

procedure TMain.CancelBtnClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rfs.Free;
end;

procedure TMain.FormResize(Sender: TObject);
var
  x,y:integer;
begin
  x:=Main.ClientWidth-ExtractBtn.Width-8-CancelBtn.Width-8;
  y:=Main.ClientHeight-ExtractBtn.Height-8;

  InfoLst.Width:=Main.ClientWidth-InfoLst.Left-8;
  InfoLst.Height:=y-InfoLst.Top-8;

  ExtractBtn.Left:=x;
  ExtractBtn.Top:=y;
  CancelBtn.Left:=x+ExtractBtn.Width+8;
  CancelBtn.Top:=y;

  Label2.Top:=y+8;
end;

procedure TMain.ExtractBtnClick(Sender: TObject);
var
  SaveBackInfo:TSaveBackInfo;
  SaveData:array of byte;
  SaveSize:integer;
  wfs:TFileStream;
  idx:integer;
begin
  SaveBackInfo:=SaveBackInfos[InfoLst.ItemIndex];

  SaveDlg.FileName:=ExtractFilename(SaveBackInfo.FullPathUnicode);
  if SaveDlg.Execute=False then exit;

  SaveSize:=512*1024;
  setlength(SaveData,SaveSize);
  for idx:=0 to SaveSize-1 do begin
    SaveData[idx]:=$ff;
  end;

  rfs.Position:=512+(512*SaveBackInfoMaxCount)+(SaveSize*SaveBackInfo.SlotIndex);
  rfs.ReadBuffer(SaveData[0],SaveBackInfo.SaveSize);

  wfs:=TFileStream.Create(SaveDlg.FileName,fmCreate);
  wfs.WriteBuffer(SaveData[0],SaveSize);
  wfs.Free;
end;

end.
